﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace MyMapApp.Controls
{
	[TemplateVisualState(Name="Normal", GroupName="CommonStates")]
	[TemplateVisualState(Name = "MouseOver", GroupName = "CommonStates")]
	public class HoverControl : ContentControl
	{
#if SILVERLIGHT
		private bool IsMouseOver = false;						//SL
#endif

		public HoverControl()
		{
#if SILVERLIGHT
			this.DefaultStyleKey = typeof(HoverControl);		//SL
#endif
		}
		static HoverControl()
		{
#if !SILVERLIGHT
            DefaultStyleKeyProperty.OverrideMetadata(typeof(HoverControl), new FrameworkPropertyMetadata(typeof(HoverControl)));
#endif
		}

		public override void OnApplyTemplate()
		{
			base.OnApplyTemplate();
			ChangeVisualState(false);
		}

		protected override void OnMouseEnter(MouseEventArgs e)
		{
			base.OnMouseEnter(e);
#if SILVERLIGHT
			IsMouseOver = true;									//SL
#endif
			ChangeVisualState(true);
		}
		protected override void OnMouseLeave(MouseEventArgs e)
		{
			base.OnMouseLeave(e);
#if SILVERLIGHT
			IsMouseOver = false;								//SL
#endif
			ChangeVisualState(true);
		}

		private void ChangeVisualState(bool useTransitions)
		{
			if (IsMouseOver)
			{
				GoToState(useTransitions, "MouseOver");
			}
			else
			{
				GoToState(useTransitions, "Normal");
			}
		}

		private bool GoToState(bool useTransitions, string stateName)
		{
			return VisualStateManager.GoToState(this, stateName, useTransitions);
		}
	}
}
